"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseTypeSet = void 0;
exports.Calculation = Calculation;
exports.Operand = Operand;
exports.VariableComponent = VariableComponent;
exports.calculators = exports.VariableTypesContext = exports.VariableTypes = void 0;
exports.parseValue = parseValue;
exports.useOperandContext = useOperandContext;
exports.useVariableTypes = useVariableTypes;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _nodes = require("./nodes");

var _FlowContext = require("./FlowContext");

var _triggers = require("./triggers");

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _client2() {
  const data = require("@nocobase/utils/client");

  _client2 = function _client2() {
    return data;
  };

  return data;
}

var _locale = require("./locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function NullRender() {
  return null;
}

const calculators = new (_client2().Registry)();
exports.calculators = calculators;
calculators.register('equal', {
  name: '=',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('notEqual', {
  name: '≠',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('gt', {
  name: '>',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('gte', {
  name: '≥',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('lt', {
  name: '<',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('lte', {
  name: '≤',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('add', {
  name: '+',
  type: 'number',
  group: 'number'
});
calculators.register('minus', {
  name: '-',
  type: 'number',
  group: 'number'
});
calculators.register('multiple', {
  name: '*',
  type: 'number',
  group: 'number'
});
calculators.register('divide', {
  name: '/',
  type: 'number',
  group: 'number'
});
calculators.register('mod', {
  name: '%',
  type: 'number',
  group: 'number'
});
calculators.register('includes', {
  name: '{{t("contains")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('notIncludes', {
  name: '{{t("does not contain")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('startsWith', {
  name: '{{t("starts with")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('notStartsWith', {
  name: '{{t("not starts with")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('endsWith', {
  name: '{{t("ends with")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('notEndsWith', {
  name: '{{t("not ends with")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('concat', {
  name: `{{t("concat", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'string',
  group: 'string'
});
const calculatorGroups = [{
  value: 'boolean',
  title: '{{t("Comparision")}}'
}, {
  value: 'number',
  title: `{{t("Arithmetic calculation", { ns: "${_locale.NAMESPACE}" })}}`
}, {
  value: 'string',
  title: `{{t("String operation", { ns: "${_locale.NAMESPACE}" })}}`
}, {
  value: 'date',
  title: `{{t("Date", { ns: "${_locale.NAMESPACE}" })}}`
}];

function getGroupCalculators(group) {
  return Array.from(calculators.getEntities()).filter(([key, value]) => value.group === group);
}

const JT_VALUE_RE = /^\s*\{\{([\s\S]*)\}\}\s*$/;

function getType(value) {
  if (value == null) {
    return 'null';
  }

  const type = typeof value;

  switch (type) {
    case 'object':
      break;

    default:
      // 'boolean'
      // 'number'
      // 'bigint'
      // 'string'
      // 'symbol'
      return type;
  }

  if (value instanceof Date) {
    return 'date';
  }

  return 'object';
}

function parseValue(value, Types) {
  var _type;

  const valueType = getType(value);

  if (valueType !== 'string') {
    return {
      type: 'constant',
      value,
      options: {
        type: valueType
      }
    };
  }

  const matcher = value.match(JT_VALUE_RE);

  if (!matcher) {
    return {
      type: 'constant',
      value,
      options: {
        type: 'string'
      }
    };
  }

  const _matcher$1$split = matcher[1].split('.'),
        _matcher$1$split2 = _toArray(_matcher$1$split),
        type = _matcher$1$split2[0],
        paths = _matcher$1$split2.slice(1);

  return {
    type,
    options: paths.length ? (_type = (Types || VariableTypes)[type]) === null || _type === void 0 ? void 0 : _type.parse(paths) : {}
  };
}

const BaseTypeSet = new Set(['boolean', 'number', 'string', 'date']);
exports.BaseTypeSet = BaseTypeSet;
const ConstantTypes = {
  null: {
    title: `{{t("Null", { ns: "${_locale.NAMESPACE}" })}}`,
    value: 'null',
    default: null,
    component: NullRender
  },
  string: {
    title: `{{t("String", { ns: "${_locale.NAMESPACE}" })}}`,
    value: 'string',

    component({
      onChange: _onChange,
      value
    }) {
      return _react().default.createElement(_antd().Input, {
        value: value,
        onChange: ev => _onChange(ev.target.value)
      });
    },

    default: ''
  },
  number: {
    title: '{{t("Number")}}',
    value: 'number',

    component({
      onChange,
      value
    }) {
      return _react().default.createElement(_antd().InputNumber, {
        value: value,
        onChange: onChange
      });
    },

    default: 0
  },
  boolean: {
    title: `{{t("Boolean", { ns: "${_locale.NAMESPACE}" })}}`,
    value: 'boolean',

    component({
      onChange,
      value
    }) {
      const _useTranslation = (0, _reactI18next().useTranslation)(),
            t = _useTranslation.t;

      return _react().default.createElement(_antd().Select, {
        value: value,
        onChange: onChange,
        placeholder: t('Select')
      }, _react().default.createElement(_antd().Select.Option, {
        value: true
      }, (0, _locale.lang)('True')), _react().default.createElement(_antd().Select.Option, {
        value: false
      }, (0, _locale.lang)('False')));
    },

    default: false
  } // date: {
  //   title: '日期',
  //   value: 'date',
  //   component({ onChange, type, options, value }) {
  //     return <DatePicker value={value} onChange={v => onChange({ value: v, type, options })}/>;
  //   },
  //   default: new Date()
  // }

};
const VariableTypes = {
  constant: {
    title: `{{t("Constant", { ns: "${_locale.NAMESPACE}" })}}`,
    value: 'constant',
    options: Object.values(ConstantTypes).map(item => ({
      value: item.value,
      label: item.title
    })),

    component(props) {
      var _ConstantTypes$option;

      const _useOperandContext = useOperandContext(),
            _useOperandContext$op = _useOperandContext.options,
            options = _useOperandContext$op === void 0 ? {
        type: 'string'
      } : _useOperandContext$op;

      return (_ConstantTypes$option = ConstantTypes[options.type]) === null || _ConstantTypes$option === void 0 ? void 0 : _ConstantTypes$option.component(props);
    },

    appendTypeValue({
      options = {
        type: 'string'
      }
    }) {
      return (options === null || options === void 0 ? void 0 : options.type) ? [options.type] : [];
    },

    onTypeChange([type, optionsType], onChange) {
      const value = ConstantTypes[optionsType].default;
      onChange(value);
    },

    parse(path) {
      return {
        path
      };
    }

  },
  $jobsMapByNodeId: {
    title: `{{t("Node result", { ns: "${_locale.NAMESPACE}" })}}`,
    value: '$jobsMapByNodeId',

    options() {
      const node = (0, _nodes.useNodeContext)();
      const stack = [];

      for (let current = node.upstream; current; current = current.upstream) {
        const _instructions$get = _nodes.instructions.get(current.type),
              getter = _instructions$get.getter; // Note: consider `getter` as the key of a value available node


        if (getter) {
          var _current$title;

          stack.push({
            value: current.id,
            label: (_current$title = current.title) !== null && _current$title !== void 0 ? _current$title : `#${current.id}`
          });
        }
      }

      return stack;
    },

    component(props) {
      const _useFlowContext = (0, _FlowContext.useFlowContext)(),
            nodes = _useFlowContext.nodes;

      const _useOperandContext2 = useOperandContext(),
            options = _useOperandContext2.options;

      if (!(options === null || options === void 0 ? void 0 : options.nodeId)) {
        return null;
      }

      const node = nodes.find(n => n.id == options.nodeId);

      if (!node) {
        return null;
      }

      const instruction = _nodes.instructions.get(node.type);

      return instruction === null || instruction === void 0 ? void 0 : instruction.getter(props);
    },

    appendTypeValue({
      options = {}
    }) {
      return options.nodeId ? [Number.parseInt(options.nodeId, 10)] : [];
    },

    onTypeChange([type, nodeId], onChange) {
      onChange(`{{${type}.${nodeId}}}`);
    },

    parse([nodeId, ...path]) {
      return {
        nodeId,
        path: path.join('.')
      };
    },

    stringify(next) {
      return `{{${next.join('.')}}}`;
    }

  },
  $context: {
    title: `{{t("Trigger variables", { ns: "${_locale.NAMESPACE}" })}}`,
    value: '$context',

    options() {
      var _trigger$getOptions, _trigger$getOptions2;

      const _useFlowContext2 = (0, _FlowContext.useFlowContext)(),
            workflow = _useFlowContext2.workflow;

      const trigger = _triggers.triggers.get(workflow.type);

      return (_trigger$getOptions = trigger === null || trigger === void 0 ? void 0 : (_trigger$getOptions2 = trigger.getOptions) === null || _trigger$getOptions2 === void 0 ? void 0 : _trigger$getOptions2.call(trigger, workflow.config)) !== null && _trigger$getOptions !== void 0 ? _trigger$getOptions : null;
    },

    component(props) {
      const _useFlowContext3 = (0, _FlowContext.useFlowContext)(),
            workflow = _useFlowContext3.workflow;

      const trigger = _triggers.triggers.get(workflow.type);

      return trigger === null || trigger === void 0 ? void 0 : trigger.getter(props);
    },

    appendTypeValue({
      options
    }) {
      return options.type ? [options.type] : [];
    },

    onTypeChange([type, optionType], onChange) {
      onChange(`{{${type}.${optionType}}}`);
    },

    parse([type, ...path]) {
      return _objectSpread({
        type
      }, (path === null || path === void 0 ? void 0 : path.length) ? {
        path: path.join('.')
      } : {});
    },

    stringify(next) {
      return `{{${next.join('.')}}}`;
    }

  } // calculation: Calculation

};
exports.VariableTypes = VariableTypes;

const VariableTypesContext = _react().default.createContext({});

exports.VariableTypesContext = VariableTypesContext;

function useVariableTypes() {
  return _react().default.useContext(VariableTypesContext);
}

const OperandContext = _react().default.createContext(null);

function useOperandContext() {
  return _react().default.useContext(OperandContext);
}

function Operand({
  value = null,
  onChange: _onChange2,
  children
}) {
  const compile = (0, _client().useCompile)();
  const Types = useVariableTypes();
  const operand = parseValue(value, Types);
  const type = operand.type;

  const _ref = Types[type] || {},
        _ref$component = _ref.component,
        Variable = _ref$component === void 0 ? NullRender : _ref$component,
        appendTypeValue = _ref.appendTypeValue;

  return _react().default.createElement("div", {
    className: (0, _css().css)`
      display: flex;
      gap: .5em;
      align-items: center;
    `
  }, _react().default.createElement(_antd().Cascader, {
    allowClear: false,
    value: [Types[type] ? type : '', ...(appendTypeValue ? appendTypeValue(operand) : [])],
    options: Object.values(Types).map(item => {
      const options = typeof item.options === 'function' ? item.options() : item.options;
      return {
        label: compile(item.title),
        value: item.value,
        children: compile(options),
        disabled: options && !options.length,
        isLeaf: !options
      };
    }),
    onChange: next => {
      // 类型变化，包括主类型和子类型
      const _Types$next$ = Types[next[0]],
            onTypeChange = _Types$next$.onTypeChange,
            stringify = _Types$next$.stringify; // 自定义处理

      if (typeof onTypeChange === 'function') {
        return onTypeChange(next, _onChange2);
      } // 主类型变化


      if (next[0] !== type) {
        if (next[0] === 'constant') {
          return _onChange2(null);
        } else if (stringify) {
          return _onChange2(stringify(next));
        }

        return _onChange2({
          type: next[0],
          value: null
        });
      }
    }
  }), _react().default.createElement(OperandContext.Provider, {
    value: operand
  }, children !== null && children !== void 0 ? children : _react().default.createElement(Variable, {
    value: operand.value,
    onChange: _onChange2
  })));
}

function Calculation({
  calculator,
  operands = [null],
  onChange: _onChange3
}) {
  const _useWorkflowTranslati = (0, _locale.useWorkflowTranslation)(),
        t = _useWorkflowTranslati.t;

  const compile = (0, _client().useCompile)();
  return _react().default.createElement(VariableTypesContext.Provider, {
    value: VariableTypes
  }, _react().default.createElement("div", {
    className: (0, _css().css)`
        display: flex;
        gap: .5em;
        align-items: center;
      `
  }, _react().default.createElement(Operand, {
    value: operands[0],
    onChange: v => _onChange3({
      calculator,
      operands: [v, operands[1]]
    })
  }), typeof operands[0] !== 'undefined' ? _react().default.createElement(_react().default.Fragment, null, _react().default.createElement(_antd().Select, {
    value: calculator,
    onChange: v => _onChange3({
      operands,
      calculator: v
    }),
    placeholder: t('Calculator')
  }, calculatorGroups.filter(group => Boolean(getGroupCalculators(group.value).length)).map(group => _react().default.createElement(_antd().Select.OptGroup, {
    key: group.value,
    label: compile(group.title)
  }, getGroupCalculators(group.value).map(([value, {
    name
  }]) => _react().default.createElement(_antd().Select.Option, {
    key: value,
    value: value
  }, compile(name)))))), _react().default.createElement(Operand, {
    value: operands[1],
    onChange: v => _onChange3({
      calculator,
      operands: [operands[0], v]
    })
  })) : null));
}

function VariableComponent({
  value,
  onChange,
  renderSchemaComponent
}) {
  const VTypes = _objectSpread(_objectSpread({}, VariableTypes), {}, {
    constant: {
      title: `{{t("Constant", { ns: "${_locale.NAMESPACE}" })}}`,
      value: 'constant'
    }
  });

  const _parseValue = parseValue(value, VTypes),
        type = _parseValue.type;

  return _react().default.createElement(VariableTypesContext.Provider, {
    value: VTypes
  }, _react().default.createElement(Operand, {
    value: value,
    onChange: onChange
  }, type === 'constant' ? renderSchemaComponent() : null));
}