import { Plugin } from '@nocobase/server';
import { Registry } from '@nocobase/utils';
import { Instruction } from './instructions';
import ExecutionModel from './models/Execution';
import JobModel from './models/Job';
import WorkflowModel from './models/Workflow';
import { Trigger } from './triggers';
declare type Pending = [ExecutionModel, JobModel?];
export default class WorkflowPlugin extends Plugin {
    instructions: Registry<Instruction>;
    triggers: Registry<Trigger>;
    calculators: Registry<Function>;
    extensions: typeof import("./extensions/assignees").default[];
    executing: ExecutionModel | null;
    pending: Pending[];
    events: [WorkflowModel, any, {
        context?: any;
    }][];
    onBeforeSave: (instance: WorkflowModel, options: any) => Promise<void>;
    load(): Promise<void>;
    toggle(workflow: WorkflowModel, enable?: boolean): void;
    trigger(workflow: WorkflowModel, context: Object, options?: {
        context?: any;
    }): void;
    private prepare;
    resume(job: any): Promise<void>;
    private dispatch;
    private process;
    private createProcessor;
}
export {};
