"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _ejs() {
  const data = require("ejs");

  _ejs = function _ejs() {
    return data;
  };

  return data;
}

function _axios() {
  const data = _interopRequireDefault(require("axios"));

  _axios = function _axios() {
    return data;
  };

  return data;
}

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

class _default {
  constructor(plugin) {
    var _this = this;

    this.plugin = void 0;

    this.request = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (node, job, processor) {
        const templateVars = {
          node: processor.jobsMapByNodeId,
          ctx: processor.execution.context,
          $jobsMapByNodeId: processor.jobsMapByNodeId,
          $context: processor.execution.context
        };
        const requestConfig = node.config; // default headers

        const headers = {
          'Content-Type': 'application/json'
        };
        const _requestConfig$header = requestConfig.headers,
              headerArr = _requestConfig$header === void 0 ? [] : _requestConfig$header,
              _requestConfig$method = requestConfig.method,
              method = _requestConfig$method === void 0 ? 'POST' : _requestConfig$method,
              _requestConfig$timeou = requestConfig.timeout,
              timeout = _requestConfig$timeou === void 0 ? 5000 : _requestConfig$timeou;
        headerArr.forEach(header => headers[header.name] = header.value);
        let url, data;

        try {
          url = yield (0, _ejs().render)(requestConfig.url.trim(), templateVars, {
            async: true
          });
          data = requestConfig.data ? yield (0, _ejs().render)(requestConfig.data.trim(), templateVars, {
            async: true
          }) : undefined;
        } catch (error2) {
          // console.error(error2);
          job.set({
            status: _constants.JOB_STATUS.REJECTED,
            result: error2.message
          });
        }

        try {
          const response = yield _axios().default.request({
            url,
            method,
            headers,
            data,
            timeout
          });
          job.set({
            status: _constants.JOB_STATUS.RESOLVED,
            result: response.data
          });
        } catch (error1) {
          // console.error('axios error?', error1);
          job.set({
            status: _constants.JOB_STATUS.REJECTED,
            result: error1.isAxiosError ? error1.toJSON() : error1.message
          });
        }

        return _this.plugin.resume(job);
      });

      return function (_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      };
    }();

    this.plugin = plugin;
  }

  run(node, input, processor) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      const job = yield processor.saveJob({
        status: _constants.JOB_STATUS.PENDING,
        nodeId: node.id
      });
      setTimeout(() => {
        _this2.request(node, job, processor);
      });
      return job;
    })();
  }

  resume(node, job, processor) {
    return _asyncToGenerator(function* () {
      const ignoreFail = node.config.ignoreFail;

      if (ignoreFail) {
        job.set('status', _constants.JOB_STATUS.RESOLVED);
      }

      return job;
    })();
  }

}

exports.default = _default;